QCPItemTracer Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Public Members | Protected Functions
QCPItemTracer Class Reference

Item that sticks to QCPGraph data points. More...

Inheritance diagram for QCPItemTracer:

## Public Types
enum | TracerStyle

## Public Functions
| QCPItemTracer (QCustomPlot *parentPlot)
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
double | size () const
TracerStyle | style () const
QCPGraph * | graph () const
double | graphKey () const
bool | interpolating () const
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setSize (double size)
void | setStyle (TracerStyle style)
void | setGraph (QCPGraph *graph)
void | setGraphKey (double key)
void | setInterpolating (bool enabled)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
void | updatePosition ()
Public Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const =0
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
bool | realVisibility () const

## Public Members
QCPItemPosition *const | position

## Protected Functions
virtual void | draw (QCPPainter *painter)
QPen | mainPen () const
QBrush | mainBrush () const
Protected Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | draw (QCPPainter *painter)=0
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual QPointF | anchorPixelPosition (int anchorId) const
double | rectDistance (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const =0
virtual void | draw (QCPPainter *painter)=0
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

Item that sticks to QCPGraph data points.

Tracer example. Blue dotted circles are anchors, solid blue discs are positions.

The tracer can be connected with a QCPGraph via setGraph. Then it will automatically adopt the coordinate axes of the graph and update its position to be on the graph's data. This means the key stays controllable via setGraphKey, but the value will follow the graph data. If a QCPGraph is connected, note that setting the coordinates of the tracer item directly via position will have no effect because they will be overriden in the next redraw (this is when the coordinate update happens).

If the specified key in setGraphKey is outside the key bounds of the graph, the tracer will stay at the corresponding end of the graph.

With setInterpolating you may specify whether the tracer may only stay exactly on data points or whether it interpolates data points linearly, if given a key that lies between two data points of the graph.

The tracer has different visual styles, see setStyle. It is also possible to make the tracer have no own visual appearance (set the style to tsNone), and just connect other item positions to the tracer position (used as an anchor) via QCPItemPosition::setParentAnchor.

Note
  The tracer position is only automatically updated upon redraws. So when the data of the graph changes and immediately afterwards (without a redraw) the position coordinates of the tracer are retrieved, they will not reflect the updated data of the graph. In this case updatePosition must be called manually, prior to reading the tracer coordinates.

## Member Enumeration Documentation

## ◆ TracerStyle

enum QCPItemTracer::TracerStyle

The different visual appearances a tracer item can have. Some styles size may be controlled with setSize.

See also
  setStyle

Enumerator
tsNone | The tracer is not visible.
tsPlus | A plus shaped crosshair with limited size.
tsCrosshair | A plus shaped crosshair which spans the complete axis rect.
tsCircle | A circle.
tsSquare | A square.

## Constructor & Destructor Documentation

## ◆ QCPItemTracer()

QCPItemTracer::QCPItemTracer | ( | QCustomPlot * | parentPlot | ) |
| explicit

Creates a tracer item and sets default values.

The created item is automatically registered with parentPlot. This QCustomPlot instance takes ownership of the item, so do not delete it manually but use QCustomPlot::removeItem() instead.

## Member Function Documentation

## ◆ setPen()

void QCPItemTracer::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line of the tracer

See also
  setSelectedPen, setBrush

## ◆ setSelectedPen()

void QCPItemTracer::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line of the tracer when selected

See also
  setPen, setSelected

## ◆ setBrush()

void QCPItemTracer::setBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to draw any fills of the tracer

See also
  setSelectedBrush, setPen

## ◆ setSelectedBrush()

void QCPItemTracer::setSelectedBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to draw any fills of the tracer, when selected.

See also
  setBrush, setSelected

## ◆ setSize()

void QCPItemTracer::setSize | ( | double | size | ) |

Sets the size of the tracer in pixels, if the style supports setting a size (e.g. tsSquare does, tsCrosshair does not).

## ◆ setStyle()

void QCPItemTracer::setStyle | ( | QCPItemTracer::TracerStyle | style | ) |

Sets the style/visual appearance of the tracer.

If you only want to use the tracer position as an anchor for other items, set style to tsNone.

## ◆ setGraph()

void QCPItemTracer::setGraph | ( | QCPGraph * | graph | ) |

Sets the QCPGraph this tracer sticks to. The tracer position will be set to type QCPItemPosition::ptPlotCoords and the axes will be set to the axes of graph.

To free the tracer from any graph, set graph to `nullptr`. The tracer position can then be placed freely like any other item position. This is the state the tracer will assume when its graph gets deleted while still attached to it.

See also
  setGraphKey

## ◆ setGraphKey()

void QCPItemTracer::setGraphKey | ( | double | key | ) |

Sets the key of the graph's data point the tracer will be positioned at. This is the only free coordinate of a tracer when attached to a graph.

Depending on setInterpolating, the tracer will be either positioned on the data point closest to key, or will stay exactly at key and interpolate the value linearly.

See also
  setGraph, setInterpolating

## ◆ setInterpolating()

void QCPItemTracer::setInterpolating | ( | bool | enabled | ) |

Sets whether the value of the graph's data points shall be interpolated, when positioning the tracer.

If enabled is set to false and a key is given with setGraphKey, the tracer is placed on the data point of the graph which is closest to the key, but which is not necessarily exactly there. If enabled is true, the tracer will be positioned exactly at the specified key, and the appropriate value will be interpolated from the graph's data points linearly.

See also
  setGraph, setGraphKey

## ◆ selectTest()

double QCPItemTracer::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/ deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

In the case of 1D Plottables (QCPAbstractPlottable1D, like QCPGraph or QCPBars) details will be set to a QCPDataSelection, describing the closest data point to pos.

You may pass `nullptr` as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, mousePressEvent, wheelEvent, QCustomPlot::setInteractions, QCPAbstractPlottable1D::selectTestRect

Implements QCPAbstractItem.

## ◆ updatePosition()

void QCPItemTracer::updatePosition | ( |  | ) |

If the tracer is connected with a graph (setGraph), this function updates the tracer's position to reside on the graph data, depending on the configured key (setGraphKey).

It is called automatically on every redraw and normally doesn't need to be called manually. One exception is when you want to read the tracer coordinates via position and are not sure that the graph's data (or the tracer key with setGraphKey) hasn't changed since the last redraw. In that situation, call this function before accessing position, to make sure you don't get out-of-date coordinates.

If there is no graph set on this tracer, this function does nothing.

## ◆ draw()

void QCPItemTracer::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

Draws this item with the provided painter.

The cliprect of the provided painter is set to the rect returned by clipRect before this function is called. The clipRect depends on the clipping settings defined by setClipToAxisRect and setClipAxisRect.

Implements QCPAbstractItem.

## ◆ mainPen()

QPen QCPItemTracer::mainPen | ( |  | ) | const
| protected

Returns the pen that should be used for drawing lines. Returns mPen when the item is not selected and mSelectedPen when it is.

## ◆ mainBrush()

QBrush QCPItemTracer::mainBrush | ( |  | ) | const
| protected

Returns the brush that should be used for drawing fills of the item. Returns mBrush when the item is not selected and mSelectedBrush when it is.

The documentation for this class was generated from the following files:

- src/items/item-tracer.h
- src/items/item-tracer.cpp